Subject: Re: bootloading 2.2.1 kernel from RISC OS

From: John Ballance <[email-masked]>
Date: Tue, 23 Feb 1999 16:02:33

Hi.. I've the same problem..

I'm building the latest kernels on an I386 version

I've been through everything in Phil B's guide for cross compiling
(repeatedly, and with varuois different kernel releases)

I always get this invalid compressed data message

I also would dearly love to find the answer.

n.b. I'm building on i386 mainly because I cannot get an elf compiling
system to run on my armlinux rpc, (and speed...)

logic suggests I'm being silly somewhere, but whichever way I attack it, 
I cannot get further.

n.b. is there a good reason why a kernel patchad for armlinux will nolonger
compile
for i386 without error?.. surely it would be wise to put the patches in using
version switched conditionals, rather than (apparently) wholesale change.. a
merge to
the full linux tree would then take account of most (i presume) kernel
upissuing
matters...

John

On Tue, 23 Feb, Nicholas Clark  wrote:
> In the last mail Russell King - ARM Linux Admin said:
> 
> > Nicholas Clark writes:
> > > If I make zImage then the bootloader says something like "invalid
> > > compressed data" (err1) and then halts the system.
> > 
> > Hmm, sounds like the boot loader is not mapping the kernel correctly.
> > 
> > > If I try vmlinux (is that the uncompressed kernel, or am I daft here)
> > > it just locks up.
> > 
> > This is the expected behaviour.
> 
> :-)
> 
> I've been told that I need to make Image so I did.
>  
> > > I've looked at the top of the zImage file and the first 4 bytes differ
> > > between 2.2.1 and 2.0.35 but are the same between the 3 2.0.35 kernels
> > > I have - has the format changed?
> > 
> > Ever so slightly, but I wasn't aware that old loaders couldn't load it.
> > 
> > > I tried downloading the bootladoer from the ARMlinux ftp site, but
> > > it's dated 1997 so I don't think that'll help me.
> > 
> > There are later - see /pub/armlinux/testing
> 
> Got one dated 21 Feb 1999 (IIRC)
> 
> using zImage
> bootloader asks about arguments to kernel (as expected)
> error about "invalid compressed data" (as above)
> 
> using Image as my kernel:
> bootloader asks about arguments to kernel
> system locks up after I press return (no text messages as linux starts)
> 
> I've tried rebuilding with my a.out-> elf cross compiler instead of my
> elf native compiler, but no change to the above.
> 
> My zImage is 540000 ish bytes long, which Russell thinks is a bit short.
> I did try answering M to as many configuration questions as I could.
> 
> I'm pretty much out of inspiration as to what to do next.
> 
> Nick
> unsubscribe: body of `unsubscribe linux-arm' to [email-masked]

-- 

      Add 11 ukp (UK) carriage and VAT to all quoted prices
      
                      John Ballance
 Castle Technology, Ore Trading Estate, Woodbridge Road, Framlingham,
Suffolk UK IP13 9LL  Tel  44 (0) 1728 621 631, Fax  44 (0) 1728 621 179
web: http://www.castle-technology.co.uk or http://www.castlet.demon.co.uk

unsubscribe: body of `unsubscribe linux-arm' to [email-masked]

---

From: Russell King - ARM Linux Admin <[email-masked]>
Date: Tue, 23 Feb 1999 16:29:55 +0000 (GMT)

> I always get this invalid compressed data message

I'm thinking that this is a problem with the compiler or binutils.  My kernels
are OK, and if I send my kernel to someone with this problem, they have no
problems with my zImage.

> compile for i386 without error?

What is the error?

> surely it would be wise to put the patches in using version switched
> conditionals, rather than (apparently) wholesale change.. a merge to
> upissuing matters...

I take care of the patches - patching a kernel is not a one-way affair -
so long as you have the original patch around, it's easy to remove it.
conditionals would just make a mess of everything and make it unreadable.
   _____
  |_____| ------------------------------------------------- ---+---+-
  |   |        Russell King       [email-masked]      --- ---
  | | | |  http://www.arm.linux.org.uk/~rmk/armlinux.html    /  /  |
  | +-+-+                                                     --- -+-
  /   |               THE developer of ARM Linux              |+| /|\
 /  | | |                                                     ---  |
    +-+-+ -------------------------------------------------  /\\\  |
unsubscribe: body of `unsubscribe linux-arm' to [email-masked]

---

From: Philip Blundell <[email-masked]>
Date: Tue, 23 Feb 1999 18:28:15 +0000

>I'm thinking that this is a problem with the compiler or binutils.

It's possible.  You could try reducing the optimisation to -O (in linux/
Makefile) and see if that makes things work any better.  If you're using 
anything other than binutils 2.9.1.0.19a and the latest egcs-1.1.1 it would be 
worth upgrading.

FWIW, I build all my A5000 kernels with these tools and haven't had a problem.

p.